theory Defs
  imports Main
begin

datatype 'a tree = Leaf | Node "'a tree" 'a "'a tree"

fun insert_pq :: "'a::linorder \<Rightarrow> 'a tree \<Rightarrow> 'a tree" where
  "insert_pq a Leaf = Node Leaf a Leaf" |
  "insert_pq a (Node l x r) =
   (if a < x then Node (insert_pq x r) a l else Node (insert_pq a r) x l)"

end
